function [ loss, lossA, lossB, lossC ] = compute_loss( x, z, K, U, L, mu, d, lambda, s )

    n = size(x, 1);
    D = size(x, 2);
    
    % Part A. cluster number penalty
    lossA = lambda * K;
    
    % Part B. subspace dimension penalty
    lossB = 0;
    for k = 1:K
        lossB = lossB + s * d(k);
    end
    
    % Part C. modeling likelihood
    lossC = 0;
    for k = 1:K
        ind = (z == k * ones(n, 1)); % n x 1
        Uk = squeeze(U(k, :, :)); % D x D
        muk = mu(k, :); % 1 x D
        t = (x - muk(ones(n, 1), :)) * Uk; % n x D, (x-mu)' * U
        t2 = (ind(:, ones(1, D)) .* t) .^ 2;
        lossC = lossC + sum(sum(t2(:, d(k)+1:D)));
    end
    
    loss = lossA + lossB + lossC;

end

