function [ acc ] = evaluate_biclustering( z, z_ref )
% z, zref: int P x 1, zref \in {1, 2}^P

    assert(size(z, 1) == size(z_ref, 1));
    assert(max(z_ref) == 2);
    K = max(max(z), 2);
    n = size(z, 1);
    acc = 0;
    
    for i = 1:K
        for j = 1:K
            if (i ~= j)
                zt = zeros(n, 1);
                zt = zt + 1 * (z == i * ones(n, 1));
                zt = zt + 2 * (z == j * ones(n, 1));
                t = mean(zt == z_ref);
                if (t > acc)
                    acc = t;
                end
            end
        end
    end

end

