% validate1_dpspace

T = 10;
n = 100000;
m = 10000;
maxK = 10;
maxT = 50;
eps = 1e-3;
D = 10;

%zT1 = zeros(T, n);
%KT1 = zeros(T, 1);
%WT1 = zeros(T, maxK, D, D);
%muT1 = zeros(T, maxK, D);
%dT1 = zeros(T, maxK);
%nmiT1 = zeros(T, 1);
%rT1 = zeros(T, 1);
%lambdaT1 = zeros(T, 1);
%sT1 = zeros(T, 1);

lambdas = [10 25 50 100 250 500 1000];
ss = [0.1 0.25 0.5 1 2.5 5 10 25 50 100];

%for t = 1:T

t = 7;
    
    fprintf('Round %d ...\n', t);
    
    x0 = squeeze(x(t, :, :));
    z0 = squeeze(z(t, :))';
    
    % First: do model selection
    max_nmi = -1;
    lambda = 1; s = 1;
    for i = 1:size(lambdas, 2)
        for j = 1:size(ss, 2)
            [z1, K1, W1, mu1, d1] = dpspace(x0(1:m,:), lambdas(i), ss(j), 1, maxK, maxT, eps, 1);
            nmi1 = compute_nmi(z1, z0(1:m));
            if (nmi1 > max_nmi)
                max_nmi = nmi1;
                lambda = lambdas(i);
                s = ss(j) * 10;
            end
        end
    end
    
    disp([lambda s]);
    lambdaT1(t) = lambda;
    sT1(t) = s;
    
    % Now: do the real clustering
    tt = cputime;
    [z1, K1, W1, mu1, d1] = dpspace(x0, lambda, s, 1, maxK, maxT, eps, 0);
    rT1(t) = cputime - tt;
    zT1(t, :) = z1';
    KT1(t) = K1;
    WT1(t, 1:K1, :, :) = W1;
    muT1(t, 1:K1, :) = mu1;
    dT1(t, 1:K1) = d1';
    nmiT1(t) = compute_nmi(z1, z0);
    fprintf('NMI = %f\n', nmiT1(t));
    
%end